require 'getopts'
unless getopts(nil, "csv")
  raise
end

def tokenize(sentence)
  s = " " + sentence + " "
  s.gsub!(/\s+/," ")
  s.gsub!(/(\s+)''/,'\1"')
  s.gsub!(/(\s+)``/,'\1"')
  s.gsub!(/''(\s+)/,'"\1')
  s.gsub!(/``(\s+)/,'"\1')
  s.gsub!(/ (['`]+)([^0-9].+) /,' \1 \2 ')
  s.gsub!(/([ (\[{<])"/,'\1 `` ')
  s.gsub!(/\.\.\./,' ... ')
  s.gsub!(/[,;:@\#$%&]/,' \& ')
  s.gsub!(/([^.])([.])([\])}>"']*)[ 	]*$/,'\1 \2\3 ')
  s.gsub!(/[?!]/,' \& ')
  s.gsub!(/[\]\[(){}<>]/,' \& ')
  s.gsub!(/--/,' -- ')
  s.sub!(/$/,' ')
  s.sub!(/^/,' ')
  s.gsub!(/"/,' \'\' ')
  while s.sub!(/(\s)([0-9]+) , ([0-9]+)(\s)/, '\1\2,\3\4')
  end
  s.gsub!(/\//, ' / ')
  s.gsub!(/\s+/,' ')
  s.strip!
  return s
end

freq = Hash.new(0)
while line = gets
  line.gsub!(/\r/,'')
  line.chomp!
  tokenize(line).split.each{|w|
    w.sub!(/\.$/,'')
    freq[w.upcase] += 1
  }
end
freq.keys.sort.each{|w|
  if $OPT_csv
    print [freq[w],w].join(",") + "\r\n" if w =~ /[A-Z0-9]/
  else
    print [freq[w],w].join("\t") + "\r\n" if w =~ /[A-Z0-9]/
  end
}
