
require 'getopts'
unless getopts(nil, "debug", "force")
  raise
end

#
# ɤ߹
#
ratio = {}
open(ARGV.shift).each{|line|
  line.gsub!(/\r/,'')
  line.chomp!
  if line =~ /\s*([0-9]+)[*]([^s+]+)\s+(.+)/
    percentage, word, lemma = $1.to_f, $2, $3
    ratio[word] = {} unless ratio[word]
    ratio[word][lemma] = percentage*0.01
  end
}

if $OPT_debug
  ratio.keys.sort.each{|word|
    ratio[word].keys.sort.each{|lemma|
      print [word, lemma, ratio[word][lemma]].join(', ') + "\r\n"
    }
  }
end

#
# ǡɤ߹
#
registered = Hash.new(0)
unk = Hash.new(0)

open(ARGV.shift).each{|line|
  line.gsub!(/\r/,'')
  line.chomp!
  freq, word = line.split
  freq = freq.to_f

  if ratio[word]
    ratio[word].keys.each{|lemma|
      fraction = freq * ratio[word][lemma]
      registered[lemma] += fraction
      if $OPT_debug
	print [word, lemma, freq, ratio[word][lemma],
	  registered[lemma]].join("\t") + "\r\n"
      end
    }
  else
    unk[word] += freq
  end
}

headFile = ARGV.shift
if !$OPT_force && FileTest.exist?(headFile)
  raise "#{headFile} exists."
else
  open(headFile, "w"){|fd|
    registered.keys.sort.each{|lemma|
      f = registered[lemma].round
      if f > 0
	fd.print [f, lemma].join("\t") + "\r\n"
      end
    }
  }
end

cpyFile = ARGV.shift
if !$OPT_force && FileTest.exist?(cpyFile)
  raise "#{cpyFile} exists."
else
  open(cpyFile, "w"){|fd|
    unk.keys.sort.each{|lemma|
      f = unk[lemma].round
      if f > 0
	fd.print [f, lemma].join(" ") + "\r\n"
      end
    }
  }
end
